VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "GraphicBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright Nigel Sim 1998
'Please send any modifications to deadfx@geocities.com and they will
'be incorporated  into the release version.

Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Const LOGPIXELSX = 88
Private Const LOGPIXELSY = 90

Private Declare Function GetTextExtentPoint32 Lib "gdi32" Alias "GetTextExtentPoint32A" (ByVal hdc As Long, ByVal lpsz As String, ByVal cbString As Long, lpSize As Size) As Long
Private Type Size
    cx As Long
    cy As Long
End Type

'textwidth needed
Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type

Private Declare Function CreateDIBitmap Lib "gdi32" (ByVal hdc As Long, lpInfoHeader As BITMAPINFOHEADER, ByVal dwUsage As Long, lpInitBits As Any, lpInitInfo As BITMAPINFO, ByVal wUsage As Long) As Long


Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type LOGBRUSH
    lbStyle As Long
    lbColor As Long
    lbHatch As Long
End Type

Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(32) As Byte
End Type


Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function CreateBrushIndirect Lib "gdi32" (lpLogBrush As LOGBRUSH) As Long

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Type PALETTEENTRY
        peRed As Byte
        peGreen As Byte
        peBlue As Byte
        peFlags As Byte
End Type

Private Type LOGPALETTE
        palVersion As Integer
        palNumEntries As Integer
        palPalEntry(1) As PALETTEENTRY
End Type

Private Const DT_CALCRECT = &H400
Private Const DT_NOCLIP = &H100
Private Const DT_WORDBREAK = &H10


Private Const SRCCOPY = &HCC0020
Private Const SRCAND = &H8800C6
Private Const SRCPAINT = &HEE0086
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function Polyline Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreatePalette Lib "gdi32" (lpLogPalette As LOGPALETTE) As Long
Private Declare Function RealizePalette Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectPalette Lib "gdi32" (ByVal hdc As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function GetBkMode Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long

Private Const TRANSPARENT = 1


Enum Pens
    PS_DASH = 1
    PS_DASHDOT = 3
    PS_DASHDOTDOT = 4
    PS_DOT = 2
    PS_INSIDEFRAME = 6
    PS_SOLID = 0
    PS_NULL = 5
End Enum


Public Width As Long
Public Height As Long
Public CurrentX As Long
Public Currenty As Long
Public hdc As Long
Public hBitmap As Long
Dim CurrentPen As Long
Dim TrashBitmap As Long
Dim CurrentBrush As Long
Dim CurrentFont As Long
Dim BMPInfo As BITMAPINFO
Dim BMPInfoHeader As BITMAPINFOHEADER

Sub DrawLine(ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long)
'Draws a line
Dim Point1(1) As POINTAPI
Point1(0).x = X1
Point1(0).y = Y1
Point1(1).x = X2
Point1(1).y = Y2
Polyline hdc, Point1(0), 2
End Sub

Private Sub Class_Terminate()
'Clean up the objects
If hdc <> 0 Then
    TrashBitmap = SelectObject(hdc, hBitmap)
    DeleteDC hdc
    DeleteObject TrashBitmap
End If
If CurrentBrush <> 0 Then
    DeleteObject CurrentBrush
End If
If CurrentPen <> 0 Then
    DeleteObject CurrentPen
End If
If CurrentFont <> 0 Then
    DeleteObject CurrentFont
End If
End Sub

Sub PaintOnto(DestDC As Long, x As Long, y As Long, Optional TWidth As Long, Optional THeight As Long)

If THeight = 0 And TWidth = 0 Then
    ' No scaleing needed
    BitBlt DestDC, x, y, Width, Height, hdc, 0, 0, SRCCOPY
Else
    'Scale it to the required size
    StretchBlt DestDC, x, y, TWidth, THeight, hdc, 0, 0, Width, Height, SRCCOPY
End If
End Sub

Sub PrintText(Text As String, Optional TransparentBG As Boolean, Optional TWidth As Long, Optional THeight As Long)
Dim Area As RECT

Area.Top = Currenty
If THeight = 0 Then
    Area.Bottom = Height
Else
    Area.Bottom = THeight
End If
Area.Left = CurrentX
If TWidth = 0 Then
    Area.Right = Width
Else
    Area.Right = TWidth
End If

If TransparentBG Then
    Dim OldBGMode As Long
    OldBGMode = GetBkMode(hdc)
    SetBkMode hdc, TRANSPARENT
    DrawText hdc, Text, Len(Text), Area, DT_WORDBREAK
    SetBkMode hdc, OldBGMode
Else
    DrawText hdc, Text, Len(Text), Area, DT_WORDBREAK
End If

End Sub

Function CreateBuffer(ByVal Width1 As Long, ByVal Height1 As Long)
Width = Width1
Height = Height1
Dim ScreenDC As Long
ScreenDC = GetDC(0&)
hdc = CreateCompatibleDC(ScreenDC)
hBitmap = CreateCompatibleBitmap(ScreenDC, Width, Height)
TrashBitmap = SelectObject(hdc, hBitmap)
ReleaseDC 0&, ScreenDC
Clear
End Function

Sub ColourPixel(ByVal x As Long, ByVal y As Long, ByVal Colour As Long)
SetPixel hdc, x, y, Colour
End Sub

Sub SetFillColour(ByVal Colour As Long)
If CurrentBrush <> 0 Then
    DeleteObject CurrentBrush
End If
CurrentBrush = CreateSolidBrush(Colour)
SelectObject hdc, CurrentBrush
End Sub

Sub SetForeColour(ByVal Colour As Long, ByVal PenType As Pens, PenWidth As Long)
If CurrentPen <> 0 Then
    DeleteObject CurrentPen
End If
CurrentPen = CreatePen(PenType, PenWidth, Colour)
SelectObject hdc, CurrentPen
End Sub

Sub Clear()
Dim Area As RECT
Area.Top = 0
Area.Bottom = Height
Area.Left = 0
Area.Right = Width
FillRect hdc, Area, CurrentBrush
End Sub

Sub SetFont(ByVal FontName As String, ByVal Angle As Long, ByVal FontHeight As Long, ByVal FontWidth As Long, ByVal FontUnderline As Boolean, ByVal FontStrikeThrough As Boolean, ByVal FontItalics As Boolean, ByVal FontBold As Boolean)
If CurrentFont <> 0 Then
    DeleteObject CurrentFont
End If
Dim FontBits As LOGFONT
FontBits.lfHeight = FontHeight
FontBits.lfEscapement = Angle
FontBits.lfOrientation = Angle
FontBits.lfCharSet = 0
FontBits.lfClipPrecision = 0
For i = 0 To Len(FontName) - 1
    FontBits.lfFaceName(i) = Asc(Mid(FontName, i + 1, 1))
Next
FontBits.lfItalic = FontItalics
FontBits.lfOutPrecision = 0
FontBits.lfPitchAndFamily = 0
FontBits.lfQuality = 2
FontBits.lfStrikeOut = FontStrikeThrough
FontBits.lfUnderline = FontUnderline
If FontBold Then
    FontBits.lfWeight = 900
Else
    FontBits.lfWeight = 0 'Blodness
End If
FontBits.lfWidth = FontWidth
CurrentFont = CreateFontIndirect(FontBits)
SelectObject hdc, CurrentFont
End Sub

Function TextHeight(Text As String, TWidth As Long) As Long
Dim Area As RECT
Area.Top = Currenty
Area.Bottom = Height
Area.Left = CurrentX
Area.Right = TWidth
    
TextHeight = DrawText(hdc, Text, Len(Text), Area, DT_CALCRECT Or DT_WORDBREAK)

End Function

Function TextWidth(Text As String) As Long
Dim Ret As Size

Call GetTextExtentPoint32(hdc, Text, Len(Text), Ret)

TextWidth = Ret.cx
End Function

Sub SetFontSimple(FontName As String, Size As Long, Bold As Boolean, Underline As Boolean, Italic As Boolean)
Call SetFont(FontName, 0, Size / 72 * GetDeviceCaps(hdc, LOGPIXELSY), 0, Underline, False, Italic, Bold)
End Sub
